package com.jpattern.orm.generator.reflection;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import com.jpattern.orm.generator.ValidValueChecker;

/**
 * 
 * @author Francesco Cina'
 *
 * Apr 1, 2012
 */
public class ReflectionGeneratorManipulator extends GeneratorManipulator {

	private final Method valuesChecherMethod;
	private final long[] validValues;
	private final FieldManipulator fieldManipulator;

	public ReflectionGeneratorManipulator(Class<?> columnType, FieldManipulator fieldManipulator, long[] validValues) throws SecurityException, NoSuchMethodException {
		valuesChecherMethod = ValidValueChecker.class.getMethod(ValidValueChecker.METHOD_NAME, validValues.getClass(), columnType);
		this.fieldManipulator = fieldManipulator;
		this.validValues = validValues;
	}

	@Override
	public boolean useGenerator(Object bean) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
		return (Boolean) valuesChecherMethod.invoke(bean, validValues, fieldManipulator.getValue(bean));
	}

}
