package com.jpattern.orm.generator.wrapper;

import java.sql.Date;
import org.joda.time.DateMidnight;

/**
 * 
 * @author Francesco Cina'
 *
 * Mar 27, 2012
 */
public class JodaDateMidnightToSqlDateWrapper implements TypeWrapper<DateMidnight, Date> {

	@Override
	public Class<Date> resultSetTypeToUse() {
		return Date.class;
	}

	@Override
	public Class<DateMidnight> wrapperClass() {
		return DateMidnight.class;
	}

	@Override
	public DateMidnight wrap(final Date value) {
		if (value==null) {
			return null;
		}
		return new DateMidnight(value.getTime());
	}

	@Override
	public Date unWrap(final DateMidnight value) {
		if (value==null) {
			return null;
		}
		return new Date(value.getMillis());
	}

}
